<?php
echo (phpversion()."<br/>");

// Paramètres de la passerelle
$address = "10.10.13.252";
$port = 2300;

// Création de la socket
$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
if ($socket == false) {
	echo("Echec de creation: ".socket_strerror(socket_last_error())."<br/>");
}
else {
	//echo("Creation socket OK <br/>");
}

// Connexion à la passerelle
$result = socket_connect($socket, $address, $port);
if ($result == false) {
	echo("Echec de connexion: ".socket_strerror(socket_last_error($socket))."<br/>");
}
else {
	//echo("Connexion OK <br/>");
}

// Temporisation entre la connexion et la lecture
sleep(2);

// Lecture de la trame téléinfo
$trame = socket_read($socket, 256);
//echo($trame."<br/>");
$lgTrame = strlen($trame);
//echo("Longueur de la trame: ".$lgTrame."<br/>");

// Extraction des valeurs
if ($lgTrame >= 170) {
	// Puissance apparente
	$position = strpos($trame, "PAPP");
	//echo("Position de PAPP = ".$position."<br/>");
	$PAPP = substr($trame, $position+5, 5);
	echo("PAPP = ".$PAPP."<br/>");
	// Index heures creuses
	$position = strpos($trame, "HCHC");
	//echo("Position de HCHC = ".$position."<br/>");
	$HCHC = substr($trame, $position+5, 9);
	echo("HCHC = ".$HCHC."<br/>");
	// Index heures pleines
	$position = strpos($trame, "HCHP");
	//echo("Position de HCHP = ".$position."<br/>");
	$HCHP = substr($trame, $position+5, 9);
	echo("HCHP = ".$HCHP."<br/>");
	
	// Sauvegarde des valeurs en base
	$servername = "127.0.0.1";
	$username = "tce";
	$password = "tce";
	$dbname = "tce";

	$conn = mysqli_connect($servername, $username, $password, $dbname);

	if (!$conn) {
		die("Echec de connexion: " . mysqli_connect_error());
	}
	//echo "Connexion OK";

	$sql = "INSERT INTO compteur (PAPP, HCHC, HCHP) VALUES ('".$PAPP."', '".$HCHC."','".$HCHP."')";
	$result = mysqli_query($conn, $sql);

	mysqli_close($conn);			

}

// Fermeture de la connexion
socket_close($socket);
?>